Subject: [bug#74058] [PATCH v8 1/2] gnu: postgresql-configuration: Unset default postgresql.

From: "pelzflorian (Florian Pelz)" <[email-masked]>
Date: Sat, 16 Nov 2024 18:34:43 +0100

Nicolas Graves via Guix-patches via <[email-masked]> writes:
> -(define-deprecated (postgresql-service #:key (postgresql postgresql)
> +(define-deprecated (postgresql-service #:key (postgresql postgresql-10)

Hello Nicolas.  Sorry, another issue.

As it should be, after createdb in `guix shell postgresql@14`, reconfigure with

(service postgresql-service-type)

gives the error

guix system: Fehler: /etc/config.scm:72:21: no value specified for service of type 'postgresql'

; I change it to

(service postgresql-service-type
         (postgresql-configuration
          (postgresql postgresql-10)))

and reconfigure works again, but after rebooting,

sudo herd status

shows postgres has failed to start.

/var/log/postgresql/pg_ctl.log contains:

2024-11-15 20:37:27.366 GMT [32375] LOG:  ending log output to stderr
2024-11-15 20:37:27.366 GMT [32375] HINT:  Future log output will go to log destination "syslog".
2024-11-16 08:06:09.690 GMT [342] LOG:  ending log output to stderr
2024-11-16 08:06:09.690 GMT [342] HINT:  Future log output will go to log destination "syslog".
2024-11-16 11:48:56.075 GMT [344] LOG:  ending log output to stderr
2024-11-16 11:48:56.075 GMT [344] HINT:  Future log output will go to log destination "syslog".
2024-11-16 16:41:19.144 GMT [347] FATAL:  database files are incompatible with server
2024-11-16 16:41:19.144 GMT [347] DETAIL:  The data directory was initialized by PostgreSQL version 14, which is not compatible with this version 10.23.

Should we set the default to postgresql-14 and change /etc/news.scm to
recommend version 14, or instead recommend looking for an error in file
/var/log/postgresql/pg_ctl.log?

I used `guix shell postgresql@14` because it’s the version I get with
`guix build -e '(@ (gnu packages databases) postgresql)'`.  Was that
wrong?

Regards,
Florian